
             
;    Filename:	  PicShift200913.asm****LED5 sur pin12**avec quartz
; Pour le choix Avec ou sans quartz, choisir la bonne ligne de _CONFIG i dessous
;Avec un ";" en premire colonne elle est dsacive

;Shiftlight progressive de L5  L1   L5L4L3L2L1
 
;Il FAUT un fichier 	c:\aepl\picshift.txt contenant les 10 valeurs de lT1_H  lT5_L
;5 priodes correspondants aux rgimes d'allumage des LED
;Voir dtails en fin de listing


;Nota On peut modifier la frequence de clignotement des 5 LED par lNSPK


	ERRORLEVEL	-302, -301

	list      p=16F628A           ; list directive to define processor
	#include <p16F628A.inc>         ; processor specific variable definitions
	
;Sans quartz,  4 directement relie au +5V

;	__CONFIG   _CP_OFF & _WDT_OFF& _PWRTE_ON  &_LVP_OFF & _INTRC_OSC_NOCLKOUT & _MCLRE_ON

 
;Avec quartz, 4 directement relie au +5V


	__CONFIG   _CP_OFF & _WDT_OFF& _PWRTE_OFF  &_LVP_OFF & _XT_OSC &_MCLRE_ON  


;Pour  debug avec ICD3, il faut l'accs aux pattes 12&13, un quartz et 10Kohms entre la patte 4 et +5V	

		#INCLUDE	c:\aepl\picshift.txt	;contient les 10 valeurs lT1_H  lT5_L
	
;*****************************************************************
  		
		#DEFINE	L1	PORTB,1		;pin7, LED 1, la plus haute vitesse
		#DEFINE	L2	PORTB,2		;pin8, LED 2
		#DEFINE	L3	PORTB,4		;pin10, LED 3
		#DEFINE	L4	PORTB,5		;pin11, LED 4
		#DEFINE	L5	PORTB,6		;pin12, LED 5, la plus basse vitesse

		#DEFINE	SPK	PORTB,3		;Spark entre,CCP1  front descendant,pin9 sur 628, B0 pin6 sur 88

;VARIABLES

	cblock	h'20'	
			
	w_temp        		  ; variable used for context saving 
	status_temp   		  ; variable used for context saving
	T1_H	
	T1_L				;N max, flash en altern allON,allOFF

	T2_H	
	T2_L	   

	T3_H	
	T3_L		 

	T4_H	
	T4_L	

	T5_H	
	T5_L				;Nmin allume premire LED, L5

	T_H					;T =Periode entre deux tincelles 
	T_L					;unit de T = 8s 
	
	TR_H				;T Reference pour sub CMPT de comparaison
	TR_L
	
	FRONT				;Flag = 1 qd tincelle, ie front descendant de +5V  0 sur pin9
	
	FTIR				;Flag Tinf  TR = 1 si  T<TR, = 0 pour T>=TR
	NSPK				;nb d'tincelles pendant allON, allOFF
	BLINK				;Toggle 0,2,4 ...allOFF     1,3,5....allON	
	TMP

	endc


;Valeurs numeriques
lNSPK	equ	d'30'		;nb d'tincelles pendant allON, allOF
							;ex T=4ms, lNSPK=30, TallON = 120ms = TallOFF

;**********************************************************************
START	ORG    0             	; MEM FLASH (2K)
	goto	Main			

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ISR	ORG	h'04'			;Interrupt Service Routine, IT provenant du front SPK
							;recopie TMR1 dans CCP1, et restart TMR1
	movwf	w_temp			;Save context. First w
	swapf	STATUS,w		;twist STATUS 
	movwf	STATUS_TEMP	; and save it

	bcf		T1CON,TMR1ON	;arreter le TMR1
	clrf	TMR1H
	clrf	TMR1L			;RAZ TMR1
	bsf		T1CON,TMR1ON	;dmarrer TMR1
	movfw	CCPR1H		; sauver la priode
	movwf	T_H
	movfw	CCPR1L
	movwf	T_L				

	bsf		FRONT,0		;signaler au MAIN, tincelle arriv sur cylindre 1
Finit
	bcf		PIR1,CCP1IF	;pour eviter retour immdiat RAZ du flag d'IT

	swapf	STATUS_TEMP,w		;Restore context Untwist STATUS
	movwf	STATUS
	swapf	w_temp,f		;Twist twice since w was stored untwitesd!
	swapf	w_temp,w
	RETFIE				;Retour

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Main
	  	call		INIT			;Initialiser les variables ,IO, constantes,LCD

getT
	 btfss	FRONT,0
	 goto	getT			;attendre le front
	 clrf	FRONT
	call	ALLOFF			;tout teindre

	movfw	T1_H			;preparer TR pour la sub de comparaison CMPT
	movwf	TR_H
	movfw	T1_L
	movwf	TR_L
	call	CMPT
	btfsc	FTIR,0
	goto	Flashall		;N>N1,  tout flasher	

	movfw	T2_H			;preparer TR pour la sub de comparaison CMPT
	movwf	TR_H
	movfw	T2_L
	movwf	TR_L
	call	CMPT
	btfsc	FTIR,0
	goto	ON52			;N>N2 allumer de L5  L2		

	movfw	T3_H			;preparer TR pour la sub de comparaison CMPT
	movwf	TR_H
	movfw	T3_L
	movwf	TR_L
	call	CMPT
	btfsc	FTIR,0
	goto	ON53			;N>N3 allumer de L5  L3	

	movfw	T4_H			;preparer TR pour la sub de comparaison CMPT
	movwf	TR_H
	movfw	T4_L
	movwf	TR_L
	call	CMPT
	btfsc	FTIR,0
	goto	ON54			;N>N4, allumer L5 et L4		

	movfw	T5_H			;preparer TR pour la sub de comparaison CMPT
	movwf	TR_H
	movfw	T5_L
	movwf	TR_L
	call	CMPT
	btfsc	FTIR,0
	goto	ON5				;N>N5 allumer L5
	goto	getT			;N<N5, pas de LED

Flashall					;N>N1, tout flasher
	decfsz	NSPK,f			;fini la suite de NSPK tincelles?
	goto	NT2				;non, suivant BLINK, allumer ou teindre les 5 LED
	movlw	lNSPK			;oui recharger le compteur d'tincelles
	movwf	NSPK
	incf	BLINK,f			;toggle, (alterner) BLINK	
NT2
	btfss	BLINK,0			;blink  1,3,5...tout a
	goto	getT			;blink 0,2,4...tout teindre
ON51						;les 5 ON					
	bsf		L1
ON52						;ON L5  L2			
	bsf		L2
ON53						;ON L5  L3						
	bsf		L3	
ON54						;ON L5  L4		
	bsf		L4	
ON5							;ON L5 	
	bsf		L5

	goto	getT			;aller attendre tincelle suivante
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ALLOFF					;SUB teint les 5 LED
	bcf		L1
	bcf		L2
	bcf		L3
	bcf		L4
	bcf		L5
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ALLON					;SUB allume les 5 LED
	bsf		L1
	bsf		L2
	bsf		L3
	bsf		L4
	bsf		L5
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CMPT					;SUB Compare T  TR, 16 bits

	bsf		FTIR,0			;assume T<TR
	movfw	TR_H
	subwf	T_H,w
	btfss	STATUS,C
	goto	TinfTR
	btfss	STATUS,Z
	goto	TsupegTR
	movfw	TR_L
	subwf	T_L,w
	btfss	STATUS,C
	goto	TinfTR
TsupegTR	
	clrf		FTIR
TinfTR
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;     
INIT				;SUB d'initialisations
	movlw		7
	movwf 		cmcon		;desactive le comparateur.Indispensable!
	
	clrf		INTCON		;Aucune IT autorise
	banksel		TRISB
	bsf			TRISB,3	; input CCP1, front descendant

	bcf			TRISB,1	;output pin 7 LED1
	bcf			TRISB,2	;output pin 8 LED2
	bcf			TRISB,4	;output pin 10 LED3 	
	bcf			TRISB,5	;output pin 11 LED4
	bcf			TRISB,6	;output pin 12 LED5
	bsf			PIE1,CCP1IE	;enable IT de CCP1 pin9,RB3
	banksel		0
	movlw		h'30'
	movwf		T1CON			;Input clock pre scale /8 for 8s unit
	bsf			INTCON,PEIE	;Peripheral IT enable
	movlw		b'00000100'		;front descendant sur pin9, module CCP
	movwf		CCP1CON
;Int les priodes des LED
	movlw		lT1_H		
	movwf		T1_H
	movlw		lT1_L
	movwf		T1_L	

	movlw		lT2_H		
	movwf		T2_H
	movlw		lT2_L
	movwf		T2_L	
		
	movlw		lT3_H		
	movwf		T3_H
	movlw		lT3_L
	movwf		T3_L	
		
	movlw		lT4_H		
	movwf		T4_H
	movlw		lT4_L
	movwf		T4_L	
		
	movlw		lT5_H		
	movwf		T5_H
	movlw		lT5_L
	movwf		T5_L

	movlw		lNSPK
	movwf		NSPK	;nb de periodes pour allON, OFF		
	clrf		BLINK																																																							
	clrf		FRONT

	call		ALLOFF

	bsf			L5
	call		WAITNS
	bsf			L4
	call		WAITNS
	bsf			L3
	call		WAITNS
	bsf			L2
	call		WAITNS
	bsf			L1
	call		WAITNS

	call		ALLOFF
	call		WAITNS

	call		ALLON
	call		WAITNS
	call		ALLOFF

	bsf		INTCON, GIE
	return   
 
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WAIT_250ms				;SUB attente .25s
	 movlw	d'250'
	 movwf	TMP
	 movlw	d'250'
	 call	WAIT_4w
	 decfsz	TMP,f
	 goto	$-2
	 return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WAIT_4w					;SUB d'attente 4w s
	addlw	-1
	btfss	status,z
	goto	$-2
	return
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
WAITNS					;SUB attente 
	call	WAIT_250ms
 	call	WAIT_250ms
;	call	WAIT_250ms
;	call	WAIT_250ms
;	call	WAIT_250ms
;	call	WAIT_250ms
;	call	WAIT_250ms
;	call	WAIT_250ms
;	call	WAIT_250ms
;	call	WAIT_250ms
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

 
	END                    	; directive 'end of program':::::::::::::::::::::::::::::::::::::::::::::


;
;Calcul des lTi ( ajuster si on entre l'tincelle d'une seule bobine ou une bobine  tincelle perdue!!!)
;***************** T = (120 000 000)/(8*Ncyl*Nt/mn)**********************

;Exemple  pour N=6000t/mn et  Ncyl = 4, on trouve  T= 625 

;On calcul T_H par T/256, partie entire soit T_H = 625/256 = 2
;Puis on calcul T_L par   T_L = T - 256*T_H 

;soit					  T_L= 625 - 512 = 113

;Si T=T1
;lT1_H equ d'2'
;lT1_L equ d'113'